#include <gtkmm.h>

class ExampleWindow : public Gtk::Window {
  Gtk::VBox vbox_;
  Gtk::Label label_;
public:
  ExampleWindow(Gtk::Window&);

  bool on_delete_event(GdkEventAny*) { hide(); return true; }
};

ExampleWindow::ExampleWindow(Gtk::Window& parent)
  : label_("set_type_hint works")
{
  add(vbox_);
  vbox_.pack_start(label_);

  set_transient_for(parent);
  set_type_hint(Gdk::WINDOW_TYPE_HINT_UTILITY); // works

  signal_delete_event().connect(SigC::slot(*this, &ExampleWindow::on_delete_event));
  signal_show().connect(SigC::slot(*this, &ExampleWindow::on_show));

  show_all_children();
}

class MainWindow : public Gtk::Window {
  Gtk::VBox vbox_;
  Gtk::Button button_;
  std::auto_ptr<ExampleWindow> example_window_;
public:
  MainWindow();

  void show_example_window()
  {
    if(example_window_.get() == 0) {
      example_window_.reset(new ExampleWindow(*this));
      example_window_->show();
    }
    else {
      example_window_->show();
      example_window_->raise();
    }
  }
};

MainWindow::MainWindow()
  : button_("Show example window")
{
  add(vbox_);
  vbox_.pack_start(button_);

  button_.signal_clicked().connect(SigC::slot(*this, &MainWindow::show_example_window));
  show_all_children();
}

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);

  MainWindow mw;
  Gtk::Main::run(mw);

  return 0;
}
